	component alt_mge_phy_2 is
		port (
			csr_clk              : in  std_logic                     := 'X';             -- clk
			reset                : in  std_logic                     := 'X';             -- reset
			rx_digitalreset      : in  std_logic                     := 'X';             -- rx_digitalreset
			tx_digitalreset      : in  std_logic                     := 'X';             -- tx_digitalreset
			csr_readdata         : out std_logic_vector(15 downto 0);                    -- readdata
			csr_writedata        : in  std_logic_vector(15 downto 0) := (others => 'X'); -- writedata
			csr_address          : in  std_logic_vector(4 downto 0)  := (others => 'X'); -- address
			csr_waitrequest      : out std_logic;                                        -- waitrequest
			csr_read             : in  std_logic                     := 'X';             -- read
			csr_write            : in  std_logic                     := 'X';             -- write
			gmii16b_tx_en        : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- export
			gmii16b_tx_d         : in  std_logic_vector(15 downto 0) := (others => 'X'); -- export
			gmii16b_tx_err       : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- export
			gmii16b_rx_dv        : out std_logic_vector(1 downto 0);                     -- export
			gmii16b_rx_d         : out std_logic_vector(15 downto 0);                    -- export
			gmii16b_rx_err       : out std_logic_vector(1 downto 0);                     -- export
			led_link             : out std_logic;                                        -- export
			led_char_err         : out std_logic;                                        -- export
			led_disp_err         : out std_logic;                                        -- export
			led_an               : out std_logic;                                        -- export
			rx_clkena            : out std_logic;                                        -- export
			tx_clkena            : out std_logic;                                        -- export
			led_panel_link       : out std_logic;                                        -- export
			operating_speed      : out std_logic_vector(2 downto 0);                     -- export
			tx_serial_clk        : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- clk
			rx_cdr_refclk        : in  std_logic                     := 'X';             -- clk
			tx_clkout            : out std_logic;                                        -- clk
			rx_clkout            : out std_logic;                                        -- clk
			rx_pma_clkout        : out std_logic;                                        -- clk
			xcvr_mode            : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- export
			tx_analogreset       : in  std_logic_vector(0 downto 0)  := (others => 'X'); -- tx_analogreset
			rx_analogreset       : in  std_logic_vector(0 downto 0)  := (others => 'X'); -- rx_analogreset
			tx_analogreset_stat  : out std_logic_vector(0 downto 0);                     -- tx_analogreset_stat
			rx_analogreset_stat  : out std_logic_vector(0 downto 0);                     -- rx_analogreset_stat
			tx_digitalreset_stat : out std_logic_vector(0 downto 0);                     -- tx_digitalreset_stat
			rx_digitalreset_stat : out std_logic_vector(0 downto 0);                     -- rx_digitalreset_stat
			tx_cal_busy          : out std_logic_vector(0 downto 0);                     -- tx_cal_busy
			rx_cal_busy          : out std_logic_vector(0 downto 0);                     -- rx_cal_busy
			tx_serial_data       : out std_logic_vector(0 downto 0);                     -- tx_serial_data
			rx_serial_data       : in  std_logic_vector(0 downto 0)  := (others => 'X'); -- rx_serial_data
			rx_is_lockedtodata   : out std_logic_vector(0 downto 0);                     -- rx_is_lockedtodata
			reconfig_clk         : in  std_logic_vector(0 downto 0)  := (others => 'X'); -- clk
			reconfig_reset       : in  std_logic_vector(0 downto 0)  := (others => 'X'); -- reset
			reconfig_write       : in  std_logic_vector(0 downto 0)  := (others => 'X'); -- write
			reconfig_read        : in  std_logic_vector(0 downto 0)  := (others => 'X'); -- read
			reconfig_address     : in  std_logic_vector(10 downto 0) := (others => 'X'); -- address
			reconfig_writedata   : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			reconfig_readdata    : out std_logic_vector(31 downto 0);                    -- readdata
			reconfig_waitrequest : out std_logic_vector(0 downto 0)                      -- waitrequest
		);
	end component alt_mge_phy_2;

	u0 : component alt_mge_phy_2
		port map (
			csr_clk              => CONNECTED_TO_csr_clk,              --              csr_clk.clk
			reset                => CONNECTED_TO_reset,                --                reset.reset
			rx_digitalreset      => CONNECTED_TO_rx_digitalreset,      --      rx_digitalreset.rx_digitalreset
			tx_digitalreset      => CONNECTED_TO_tx_digitalreset,      --      tx_digitalreset.tx_digitalreset
			csr_readdata         => CONNECTED_TO_csr_readdata,         --        avalon_mm_csr.readdata
			csr_writedata        => CONNECTED_TO_csr_writedata,        --                     .writedata
			csr_address          => CONNECTED_TO_csr_address,          --                     .address
			csr_waitrequest      => CONNECTED_TO_csr_waitrequest,      --                     .waitrequest
			csr_read             => CONNECTED_TO_csr_read,             --                     .read
			csr_write            => CONNECTED_TO_csr_write,            --                     .write
			gmii16b_tx_en        => CONNECTED_TO_gmii16b_tx_en,        --        gmii16b_tx_en.export
			gmii16b_tx_d         => CONNECTED_TO_gmii16b_tx_d,         --         gmii16b_tx_d.export
			gmii16b_tx_err       => CONNECTED_TO_gmii16b_tx_err,       --       gmii16b_tx_err.export
			gmii16b_rx_dv        => CONNECTED_TO_gmii16b_rx_dv,        --        gmii16b_rx_dv.export
			gmii16b_rx_d         => CONNECTED_TO_gmii16b_rx_d,         --         gmii16b_rx_d.export
			gmii16b_rx_err       => CONNECTED_TO_gmii16b_rx_err,       --       gmii16b_rx_err.export
			led_link             => CONNECTED_TO_led_link,             --             led_link.export
			led_char_err         => CONNECTED_TO_led_char_err,         --         led_char_err.export
			led_disp_err         => CONNECTED_TO_led_disp_err,         --         led_disp_err.export
			led_an               => CONNECTED_TO_led_an,               --               led_an.export
			rx_clkena            => CONNECTED_TO_rx_clkena,            --            rx_clkena.export
			tx_clkena            => CONNECTED_TO_tx_clkena,            --            tx_clkena.export
			led_panel_link       => CONNECTED_TO_led_panel_link,       --       led_panel_link.export
			operating_speed      => CONNECTED_TO_operating_speed,      --      operating_speed.export
			tx_serial_clk        => CONNECTED_TO_tx_serial_clk,        --        tx_serial_clk.clk
			rx_cdr_refclk        => CONNECTED_TO_rx_cdr_refclk,        --      rx_cdr_refclk_0.clk
			tx_clkout            => CONNECTED_TO_tx_clkout,            --            tx_clkout.clk
			rx_clkout            => CONNECTED_TO_rx_clkout,            --            rx_clkout.clk
			rx_pma_clkout        => CONNECTED_TO_rx_pma_clkout,        --        rx_pma_clkout.clk
			xcvr_mode            => CONNECTED_TO_xcvr_mode,            --            xcvr_mode.export
			tx_analogreset       => CONNECTED_TO_tx_analogreset,       --       tx_analogreset.tx_analogreset
			rx_analogreset       => CONNECTED_TO_rx_analogreset,       --       rx_analogreset.rx_analogreset
			tx_analogreset_stat  => CONNECTED_TO_tx_analogreset_stat,  --  tx_analogreset_stat.tx_analogreset_stat
			rx_analogreset_stat  => CONNECTED_TO_rx_analogreset_stat,  --  rx_analogreset_stat.rx_analogreset_stat
			tx_digitalreset_stat => CONNECTED_TO_tx_digitalreset_stat, -- tx_digitalreset_stat.tx_digitalreset_stat
			rx_digitalreset_stat => CONNECTED_TO_rx_digitalreset_stat, -- rx_digitalreset_stat.rx_digitalreset_stat
			tx_cal_busy          => CONNECTED_TO_tx_cal_busy,          --          tx_cal_busy.tx_cal_busy
			rx_cal_busy          => CONNECTED_TO_rx_cal_busy,          --          rx_cal_busy.rx_cal_busy
			tx_serial_data       => CONNECTED_TO_tx_serial_data,       --       tx_serial_data.tx_serial_data
			rx_serial_data       => CONNECTED_TO_rx_serial_data,       --       rx_serial_data.rx_serial_data
			rx_is_lockedtodata   => CONNECTED_TO_rx_is_lockedtodata,   --   rx_is_lockedtodata.rx_is_lockedtodata
			reconfig_clk         => CONNECTED_TO_reconfig_clk,         --         reconfig_clk.clk
			reconfig_reset       => CONNECTED_TO_reconfig_reset,       --       reconfig_reset.reset
			reconfig_write       => CONNECTED_TO_reconfig_write,       --        reconfig_avmm.write
			reconfig_read        => CONNECTED_TO_reconfig_read,        --                     .read
			reconfig_address     => CONNECTED_TO_reconfig_address,     --                     .address
			reconfig_writedata   => CONNECTED_TO_reconfig_writedata,   --                     .writedata
			reconfig_readdata    => CONNECTED_TO_reconfig_readdata,    --                     .readdata
			reconfig_waitrequest => CONNECTED_TO_reconfig_waitrequest  --                     .waitrequest
		);

