	component hps_to_mge_gmii_adapter_2 is
		port (
			clock_clk                : in  std_logic                     := 'X';             -- clk
			reset_sink_reset_n       : in  std_logic                     := 'X';             -- reset_n
			csr_address              : in  std_logic                     := 'X';             -- address
			csr_read                 : in  std_logic                     := 'X';             -- read
			csr_write                : in  std_logic                     := 'X';             -- write
			csr_writedata            : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			csr_readdata             : out std_logic_vector(31 downto 0);                    -- readdata
			hps_gmii_phy_tx_clk_o    : in  std_logic                     := 'X';             -- phy_tx_clk_o
			hps_gmii_rst_tx_n        : in  std_logic                     := 'X';             -- rst_tx_n
			hps_gmii_rst_rx_n        : in  std_logic                     := 'X';             -- rst_rx_n
			hps_gmii_phy_txd_o       : in  std_logic_vector(7 downto 0)  := (others => 'X'); -- phy_txd_o
			hps_gmii_phy_txen_o      : in  std_logic                     := 'X';             -- phy_txen_o
			hps_gmii_phy_txer_o      : in  std_logic                     := 'X';             -- phy_txer_o
			hps_gmii_phy_mac_speed_o : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- phy_mac_speed_o
			hps_gmii_phy_tx_clk_i    : out std_logic;                                        -- phy_tx_clk_i
			hps_gmii_phy_rx_clk_i    : out std_logic;                                        -- phy_rx_clk_i
			hps_gmii_phy_rxdv_i      : out std_logic;                                        -- phy_rxdv_i
			hps_gmii_phy_rxer_i      : out std_logic;                                        -- phy_rxer_i
			hps_gmii_phy_rxd_i       : out std_logic_vector(7 downto 0);                     -- phy_rxd_i
			hps_gmii_phy_col_i       : out std_logic;                                        -- phy_col_i
			hps_gmii_phy_crs_i       : out std_logic;                                        -- phy_crs_i
			pll_125m_clk_clk         : in  std_logic                     := 'X';             -- clk
			pll_25m_clk_clk          : in  std_logic                     := 'X';             -- clk
			pll_2_5m_clk_clk         : in  std_logic                     := 'X';             -- clk
			pll_locked_export        : in  std_logic                     := 'X';             -- export
			phy_rx_clkout_clk        : in  std_logic                     := 'X';             -- clk
			phy_rx_clkena_export     : in  std_logic                     := 'X';             -- export
			phy_tx_clkout_clk        : in  std_logic                     := 'X';             -- clk
			phy_tx_clkena_export     : in  std_logic                     := 'X';             -- export
			phy_speed_export         : in  std_logic_vector(2 downto 0)  := (others => 'X'); -- export
			gmii16b_rx_d_export      : in  std_logic_vector(15 downto 0) := (others => 'X'); -- export
			gmii16b_rx_dv_export     : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- export
			gmii16b_rx_err_export    : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- export
			gmii16b_tx_d_export      : out std_logic_vector(15 downto 0);                    -- export
			gmii16b_tx_en_export     : out std_logic_vector(1 downto 0);                     -- export
			gmii16b_tx_err_export    : out std_logic_vector(1 downto 0)                      -- export
		);
	end component hps_to_mge_gmii_adapter_2;

	u0 : component hps_to_mge_gmii_adapter_2
		port map (
			clock_clk                => CONNECTED_TO_clock_clk,                --          clock.clk
			reset_sink_reset_n       => CONNECTED_TO_reset_sink_reset_n,       --     reset_sink.reset_n
			csr_address              => CONNECTED_TO_csr_address,              --            csr.address
			csr_read                 => CONNECTED_TO_csr_read,                 --               .read
			csr_write                => CONNECTED_TO_csr_write,                --               .write
			csr_writedata            => CONNECTED_TO_csr_writedata,            --               .writedata
			csr_readdata             => CONNECTED_TO_csr_readdata,             --               .readdata
			hps_gmii_phy_tx_clk_o    => CONNECTED_TO_hps_gmii_phy_tx_clk_o,    --       hps_gmii.phy_tx_clk_o
			hps_gmii_rst_tx_n        => CONNECTED_TO_hps_gmii_rst_tx_n,        --               .rst_tx_n
			hps_gmii_rst_rx_n        => CONNECTED_TO_hps_gmii_rst_rx_n,        --               .rst_rx_n
			hps_gmii_phy_txd_o       => CONNECTED_TO_hps_gmii_phy_txd_o,       --               .phy_txd_o
			hps_gmii_phy_txen_o      => CONNECTED_TO_hps_gmii_phy_txen_o,      --               .phy_txen_o
			hps_gmii_phy_txer_o      => CONNECTED_TO_hps_gmii_phy_txer_o,      --               .phy_txer_o
			hps_gmii_phy_mac_speed_o => CONNECTED_TO_hps_gmii_phy_mac_speed_o, --               .phy_mac_speed_o
			hps_gmii_phy_tx_clk_i    => CONNECTED_TO_hps_gmii_phy_tx_clk_i,    --               .phy_tx_clk_i
			hps_gmii_phy_rx_clk_i    => CONNECTED_TO_hps_gmii_phy_rx_clk_i,    --               .phy_rx_clk_i
			hps_gmii_phy_rxdv_i      => CONNECTED_TO_hps_gmii_phy_rxdv_i,      --               .phy_rxdv_i
			hps_gmii_phy_rxer_i      => CONNECTED_TO_hps_gmii_phy_rxer_i,      --               .phy_rxer_i
			hps_gmii_phy_rxd_i       => CONNECTED_TO_hps_gmii_phy_rxd_i,       --               .phy_rxd_i
			hps_gmii_phy_col_i       => CONNECTED_TO_hps_gmii_phy_col_i,       --               .phy_col_i
			hps_gmii_phy_crs_i       => CONNECTED_TO_hps_gmii_phy_crs_i,       --               .phy_crs_i
			pll_125m_clk_clk         => CONNECTED_TO_pll_125m_clk_clk,         --   pll_125m_clk.clk
			pll_25m_clk_clk          => CONNECTED_TO_pll_25m_clk_clk,          --    pll_25m_clk.clk
			pll_2_5m_clk_clk         => CONNECTED_TO_pll_2_5m_clk_clk,         --   pll_2_5m_clk.clk
			pll_locked_export        => CONNECTED_TO_pll_locked_export,        --     pll_locked.export
			phy_rx_clkout_clk        => CONNECTED_TO_phy_rx_clkout_clk,        --  phy_rx_clkout.clk
			phy_rx_clkena_export     => CONNECTED_TO_phy_rx_clkena_export,     --  phy_rx_clkena.export
			phy_tx_clkout_clk        => CONNECTED_TO_phy_tx_clkout_clk,        --  phy_tx_clkout.clk
			phy_tx_clkena_export     => CONNECTED_TO_phy_tx_clkena_export,     --  phy_tx_clkena.export
			phy_speed_export         => CONNECTED_TO_phy_speed_export,         --      phy_speed.export
			gmii16b_rx_d_export      => CONNECTED_TO_gmii16b_rx_d_export,      --   gmii16b_rx_d.export
			gmii16b_rx_dv_export     => CONNECTED_TO_gmii16b_rx_dv_export,     --  gmii16b_rx_dv.export
			gmii16b_rx_err_export    => CONNECTED_TO_gmii16b_rx_err_export,    -- gmii16b_rx_err.export
			gmii16b_tx_d_export      => CONNECTED_TO_gmii16b_tx_d_export,      --   gmii16b_tx_d.export
			gmii16b_tx_en_export     => CONNECTED_TO_gmii16b_tx_en_export,     --  gmii16b_tx_en.export
			gmii16b_tx_err_export    => CONNECTED_TO_gmii16b_tx_err_export     -- gmii16b_tx_err.export
		);

