module msi_irq #(
		parameter MSG_DATA_WORD    = 32,
		parameter ADDR_WIDTH       = 5,
		parameter DATA_ENTRY_DEPTH = 4,
		parameter FIFO_DEPTH       = 4,
		parameter MEMORY_TYPE      = "RAM_BLOCK_TYPE=M20K"
	) (
		input  wire                  clk,         //            clock.clk
		input  wire                  reset_n,     //            reset.reset_n
		input  wire                  csr_write,   //              csr.write
		input  wire                  csr_read,    //                 .read
		input  wire [1:0]            csr_addr,    //                 .address
		input  wire [31:0]           csr_wrdata,  //                 .writedata
		output wire [31:0]           csr_rddata,  //                 .readdata
		input  wire [ADDR_WIDTH-1:0] avmm_addr,   //     vector_slave.address
		input  wire [31:0]           avmm_wrdata, //                 .writedata
		output wire [31:0]           avmm_rddata, //                 .readdata
		input  wire                  avmm_write,  //                 .write
		input  wire                  avmm_read,   //                 .read
		output wire                  irq          // interrupt_sender.irq
	);
endmodule

