	component msi_irq is
		generic (
			MSG_DATA_WORD    : integer := 32;
			ADDR_WIDTH       : integer := 5;
			DATA_ENTRY_DEPTH : integer := 1;
			FIFO_DEPTH       : integer := 4;
			MEMORY_TYPE      : string  := "None"
		);
		port (
			clk         : in  std_logic                               := 'X';             -- clk
			reset_n     : in  std_logic                               := 'X';             -- reset_n
			csr_write   : in  std_logic                               := 'X';             -- write
			csr_read    : in  std_logic                               := 'X';             -- read
			csr_addr    : in  std_logic_vector(1 downto 0)            := (others => 'X'); -- address
			csr_wrdata  : in  std_logic_vector(31 downto 0)           := (others => 'X'); -- writedata
			csr_rddata  : out std_logic_vector(31 downto 0);                              -- readdata
			avmm_addr   : in  std_logic_vector(ADDR_WIDTH-1 downto 0) := (others => 'X'); -- address
			avmm_wrdata : in  std_logic_vector(31 downto 0)           := (others => 'X'); -- writedata
			avmm_rddata : out std_logic_vector(31 downto 0);                              -- readdata
			avmm_write  : in  std_logic                               := 'X';             -- write
			avmm_read   : in  std_logic                               := 'X';             -- read
			irq         : out std_logic                                                   -- irq
		);
	end component msi_irq;

	u0 : component msi_irq
		generic map (
			MSG_DATA_WORD    => INTEGER_VALUE_FOR_MSG_DATA_WORD,
			ADDR_WIDTH       => INTEGER_VALUE_FOR_ADDR_WIDTH,
			DATA_ENTRY_DEPTH => INTEGER_VALUE_FOR_DATA_ENTRY_DEPTH,
			FIFO_DEPTH       => INTEGER_VALUE_FOR_FIFO_DEPTH,
			MEMORY_TYPE      => STRING_VALUE_FOR_MEMORY_TYPE
		)
		port map (
			clk         => CONNECTED_TO_clk,         --            clock.clk
			reset_n     => CONNECTED_TO_reset_n,     --            reset.reset_n
			csr_write   => CONNECTED_TO_csr_write,   --              csr.write
			csr_read    => CONNECTED_TO_csr_read,    --                 .read
			csr_addr    => CONNECTED_TO_csr_addr,    --                 .address
			csr_wrdata  => CONNECTED_TO_csr_wrdata,  --                 .writedata
			csr_rddata  => CONNECTED_TO_csr_rddata,  --                 .readdata
			avmm_addr   => CONNECTED_TO_avmm_addr,   --     vector_slave.address
			avmm_wrdata => CONNECTED_TO_avmm_wrdata, --                 .writedata
			avmm_rddata => CONNECTED_TO_avmm_rddata, --                 .readdata
			avmm_write  => CONNECTED_TO_avmm_write,  --                 .write
			avmm_read   => CONNECTED_TO_avmm_read,   --                 .read
			irq         => CONNECTED_TO_irq          -- interrupt_sender.irq
		);

