// msi_irq.v

// Generated using ACDS version 19.1 240

`timescale 1 ps / 1 ps
module msi_irq #(
		parameter MSG_DATA_WORD    = 32,
		parameter ADDR_WIDTH       = 5,
		parameter DATA_ENTRY_DEPTH = 4,
		parameter FIFO_DEPTH       = 4,
		parameter MEMORY_TYPE      = "RAM_BLOCK_TYPE=M20K"
	) (
		input  wire                  clk,         //            clock.clk
		input  wire                  reset_n,     //            reset.reset_n
		input  wire                  csr_write,   //              csr.write
		input  wire                  csr_read,    //                 .read
		input  wire [1:0]            csr_addr,    //                 .address
		input  wire [31:0]           csr_wrdata,  //                 .writedata
		output wire [31:0]           csr_rddata,  //                 .readdata
		input  wire [ADDR_WIDTH-1:0] avmm_addr,   //     vector_slave.address
		input  wire [31:0]           avmm_wrdata, //                 .writedata
		output wire [31:0]           avmm_rddata, //                 .readdata
		input  wire                  avmm_write,  //                 .write
		input  wire                  avmm_read,   //                 .read
		output wire                  irq          // interrupt_sender.irq
	);

	altera_msi_to_gic_gen #(
		.DEVICE_FAMILY    ("Stratix 10"),
		.MSG_DATA_WORD    (MSG_DATA_WORD),
		.ADDR_WIDTH       (ADDR_WIDTH),
		.DATA_ENTRY_DEPTH (DATA_ENTRY_DEPTH),
		.FIFO_DEPTH       (FIFO_DEPTH),
		.MEMORY_TYPE      (MEMORY_TYPE)
	) altera_msi_to_gic_gen_inst (
		.clk         (clk),         //   input,           width = 1,            clock.clk
		.reset_n     (reset_n),     //   input,           width = 1,            reset.reset_n
		.csr_write   (csr_write),   //   input,           width = 1,              csr.write
		.csr_read    (csr_read),    //   input,           width = 1,                 .read
		.csr_addr    (csr_addr),    //   input,           width = 2,                 .address
		.csr_wrdata  (csr_wrdata),  //   input,          width = 32,                 .writedata
		.csr_rddata  (csr_rddata),  //  output,          width = 32,                 .readdata
		.avmm_addr   (avmm_addr),   //   input,  width = ADDR_WIDTH,     vector_slave.address
		.avmm_wrdata (avmm_wrdata), //   input,          width = 32,                 .writedata
		.avmm_rddata (avmm_rddata), //  output,          width = 32,                 .readdata
		.avmm_write  (avmm_write),  //   input,           width = 1,                 .write
		.avmm_read   (avmm_read),   //   input,           width = 1,                 .read
		.irq         (irq)          //  output,           width = 1, interrupt_sender.irq
	);

endmodule
