// (C) 2001-2019 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// synopsys translate_off
`timescale 1 ps / 1 ps
// synopsys translate_on

module adder_64bit  
(
      input logic                                   Clk_i,

	  input  logic [63:0]                          a_in,
	  input  logic [63:0]                          b_in,
	  output logic [63:0]                          sum_out 

 );
 

logic [67:0] sum_stage1,sum_stage3,sum_stage5;

logic [67:17] sum_stage2,sum_stage4;


assign sum_stage1[16:0]   = {1'b0,a_in[15:0]}   +  {1'b0,b_in[15:0]};
assign sum_stage1[33:17]  = {1'b0,a_in[31:16]}  +  {1'b0,b_in[31:16]}  + 1'b1;
assign sum_stage1[50:34]  = {1'b0,a_in[47:32]}  +  {1'b0,b_in[47:32]}  + 1'b1;
assign sum_stage1[67:51]  = {1'b0,a_in[63:48]}  +  {1'b0,b_in[63:48]}  + 1'b1;

assign sum_stage2[33:17]  = {1'b0,a_in[31:16]}  +  {1'b0,b_in[31:16]};
assign sum_stage2[50:34]  = {1'b0,a_in[47:32]}  +  {1'b0,b_in[47:32]};
assign sum_stage2[67:51]  = {1'b0,a_in[63:48]}  +  {1'b0,b_in[63:48]};

always_ff @(posedge Clk_i) begin
 sum_stage3  <= sum_stage1;
 sum_stage4  <= sum_stage2;
end

assign sum_stage5[16:0]  = sum_stage3[16:0];
assign sum_stage5[33:17] = sum_stage5[16] ? sum_stage3[33:17] : sum_stage4[33:17];
assign sum_stage5[50:34] = sum_stage5[33] ? sum_stage3[50:34] : sum_stage4[50:34];
assign sum_stage5[67:51] = sum_stage5[50] ? sum_stage3[67:51] : sum_stage4[67:51];

always_ff @(posedge Clk_i) begin
 sum_out  <= {sum_stage5[66:51],sum_stage5[49:34],sum_stage5[32:17],sum_stage5[15:0]};
end
endmodule
