module pcie_s10 (
		input  wire         refclk,                     //            refclk.clk,                       Check User Guide for details
		output wire         coreclkout_hip,             //    coreclkout_hip.clk,                       Check User Guide for details
		input  wire         npor,                       //              npor.npor,                      Check User Guide for details
		input  wire         pin_perst,                  //                  .pin_perst,                 Check User Guide for details
		output wire         app_nreset_status,          // app_nreset_status.reset_n,                   Check User Guide for details
		input  wire [27:0]  hptxs_address_i,            //             hptxs.address,                   Check User Guide for details
		input  wire [31:0]  hptxs_byteenable_i,         //                  .byteenable,                Check User Guide for details
		output wire [255:0] hptxs_readdata_o,           //                  .readdata,                  Check User Guide for details
		input  wire [255:0] hptxs_writedata_i,          //                  .writedata,                 Check User Guide for details
		input  wire         hptxs_read_i,               //                  .read,                      Check User Guide for details
		input  wire         hptxs_write_i,              //                  .write,                     Check User Guide for details
		input  wire [4:0]   hptxs_burstcount_i,         //                  .burstcount,                Check User Guide for details
		output wire         hptxs_readdatavalid_o,      //                  .readdatavalid,             Check User Guide for details
		output wire         hptxs_waitrequest_o,        //                  .waitrequest,               Check User Guide for details
		output wire [31:0]  rxm_bar0_address_o,         //          rxm_bar0.address,                   Check User Guide for details
		output wire [31:0]  rxm_bar0_byteenable_o,      //                  .byteenable,                Check User Guide for details
		input  wire [255:0] rxm_bar0_readdata_i,        //                  .readdata,                  Check User Guide for details
		output wire [255:0] rxm_bar0_writedata_o,       //                  .writedata,                 Check User Guide for details
		output wire         rxm_bar0_read_o,            //                  .read,                      Check User Guide for details
		output wire         rxm_bar0_write_o,           //                  .write,                     Check User Guide for details
		output wire [4:0]   rxm_bar0_burstcount_o,      //                  .burstcount,                Check User Guide for details
		input  wire         rxm_bar0_readdatavalid_i,   //                  .readdatavalid,             Check User Guide for details
		input  wire         rxm_bar0_waitrequest_i,     //                  .waitrequest,               Check User Guide for details
		input  wire [15:0]  rxm_irq_i,                  //           rxm_irq.irq,                       Check User Guide for details
		input  wire         cra_chipselect_i,           //               cra.chipselect,                Check User Guide for details
		input  wire [14:0]  cra_address_i,              //                  .address,                   Check User Guide for details
		input  wire [3:0]   cra_byteenable_i,           //                  .byteenable,                Check User Guide for details
		input  wire         cra_read_i,                 //                  .read,                      Check User Guide for details
		output wire [31:0]  cra_readdata_o,             //                  .readdata,                  Check User Guide for details
		input  wire         cra_write_i,                //                  .write,                     Check User Guide for details
		input  wire [31:0]  cra_writedata_i,            //                  .writedata,                 Check User Guide for details
		output wire         cra_waitrequest_o,          //                  .waitrequest,               Check User Guide for details
		output wire         cra_readdatavalid_o,        //                  .readdatavalid,             Check User Guide for details
		output wire         cra_irq_o,                  //           cra_irq.irq,                       Check User Guide for details
		output wire [7:0]   int_status,                 //        hip_status.int_status,                Check User Guide for details
		output wire [2:0]   int_status_common,          //                  .int_status_common,         Check User Guide for details
		output wire         derr_cor_ext_rpl,           //                  .derr_cor_ext_rpl,          Check User Guide for details
		output wire         derr_rpl,                   //                  .derr_rpl,                  Check User Guide for details
		output wire         derr_cor_ext_rcv,           //                  .derr_cor_ext_rcv,          Check User Guide for details
		output wire         derr_uncor_ext_rcv,         //                  .derr_uncor_ext_rcv,        Check User Guide for details
		output wire         rx_par_err,                 //                  .rx_par_err,                Check User Guide for details
		output wire         tx_par_err,                 //                  .tx_par_err,                Check User Guide for details
		output wire [5:0]   ltssmstate,                 //                  .ltssmstate,                Check User Guide for details
		output wire         link_up,                    //                  .link_up,                   Check User Guide for details
		output wire [4:0]   lane_act,                   //                  .lane_act,                  Check User Guide for details
		output wire [1:0]   currentspeed,               //      currentspeed.currentspeed,              Check User Guide for details
		input  wire         simu_mode_pipe,             //          hip_ctrl.simu_mode_pipe,            Check User Guide for details
		input  wire [66:0]  test_in,                    //                  .test_in,                   Check User Guide for details
		input  wire         sim_pipe_pclk_in,           //          hip_pipe.sim_pipe_pclk_in,          Check User Guide for details
		output wire [1:0]   sim_pipe_rate,              //                  .sim_pipe_rate,             Check User Guide for details
		output wire [5:0]   sim_ltssmstate,             //                  .sim_ltssmstate,            Check User Guide for details
		output wire [31:0]  txdata0,                    //                  .txdata0,                   Check User Guide for details
		output wire [31:0]  txdata1,                    //                  .txdata1,                   Check User Guide for details
		output wire [31:0]  txdata2,                    //                  .txdata2,                   Check User Guide for details
		output wire [31:0]  txdata3,                    //                  .txdata3,                   Check User Guide for details
		output wire [31:0]  txdata4,                    //                  .txdata4,                   Check User Guide for details
		output wire [31:0]  txdata5,                    //                  .txdata5,                   Check User Guide for details
		output wire [31:0]  txdata6,                    //                  .txdata6,                   Check User Guide for details
		output wire [31:0]  txdata7,                    //                  .txdata7,                   Check User Guide for details
		output wire [3:0]   txdatak0,                   //                  .txdatak0,                  Check User Guide for details
		output wire [3:0]   txdatak1,                   //                  .txdatak1,                  Check User Guide for details
		output wire [3:0]   txdatak2,                   //                  .txdatak2,                  Check User Guide for details
		output wire [3:0]   txdatak3,                   //                  .txdatak3,                  Check User Guide for details
		output wire [3:0]   txdatak4,                   //                  .txdatak4,                  Check User Guide for details
		output wire [3:0]   txdatak5,                   //                  .txdatak5,                  Check User Guide for details
		output wire [3:0]   txdatak6,                   //                  .txdatak6,                  Check User Guide for details
		output wire [3:0]   txdatak7,                   //                  .txdatak7,                  Check User Guide for details
		output wire         txcompl0,                   //                  .txcompl0,                  Check User Guide for details
		output wire         txcompl1,                   //                  .txcompl1,                  Check User Guide for details
		output wire         txcompl2,                   //                  .txcompl2,                  Check User Guide for details
		output wire         txcompl3,                   //                  .txcompl3,                  Check User Guide for details
		output wire         txcompl4,                   //                  .txcompl4,                  Check User Guide for details
		output wire         txcompl5,                   //                  .txcompl5,                  Check User Guide for details
		output wire         txcompl6,                   //                  .txcompl6,                  Check User Guide for details
		output wire         txcompl7,                   //                  .txcompl7,                  Check User Guide for details
		output wire         txelecidle0,                //                  .txelecidle0,               Check User Guide for details
		output wire         txelecidle1,                //                  .txelecidle1,               Check User Guide for details
		output wire         txelecidle2,                //                  .txelecidle2,               Check User Guide for details
		output wire         txelecidle3,                //                  .txelecidle3,               Check User Guide for details
		output wire         txelecidle4,                //                  .txelecidle4,               Check User Guide for details
		output wire         txelecidle5,                //                  .txelecidle5,               Check User Guide for details
		output wire         txelecidle6,                //                  .txelecidle6,               Check User Guide for details
		output wire         txelecidle7,                //                  .txelecidle7,               Check User Guide for details
		output wire         txdetectrx0,                //                  .txdetectrx0,               Check User Guide for details
		output wire         txdetectrx1,                //                  .txdetectrx1,               Check User Guide for details
		output wire         txdetectrx2,                //                  .txdetectrx2,               Check User Guide for details
		output wire         txdetectrx3,                //                  .txdetectrx3,               Check User Guide for details
		output wire         txdetectrx4,                //                  .txdetectrx4,               Check User Guide for details
		output wire         txdetectrx5,                //                  .txdetectrx5,               Check User Guide for details
		output wire         txdetectrx6,                //                  .txdetectrx6,               Check User Guide for details
		output wire         txdetectrx7,                //                  .txdetectrx7,               Check User Guide for details
		output wire [1:0]   powerdown0,                 //                  .powerdown0,                Check User Guide for details
		output wire [1:0]   powerdown1,                 //                  .powerdown1,                Check User Guide for details
		output wire [1:0]   powerdown2,                 //                  .powerdown2,                Check User Guide for details
		output wire [1:0]   powerdown3,                 //                  .powerdown3,                Check User Guide for details
		output wire [1:0]   powerdown4,                 //                  .powerdown4,                Check User Guide for details
		output wire [1:0]   powerdown5,                 //                  .powerdown5,                Check User Guide for details
		output wire [1:0]   powerdown6,                 //                  .powerdown6,                Check User Guide for details
		output wire [1:0]   powerdown7,                 //                  .powerdown7,                Check User Guide for details
		output wire [2:0]   txmargin0,                  //                  .txmargin0,                 Check User Guide for details
		output wire [2:0]   txmargin1,                  //                  .txmargin1,                 Check User Guide for details
		output wire [2:0]   txmargin2,                  //                  .txmargin2,                 Check User Guide for details
		output wire [2:0]   txmargin3,                  //                  .txmargin3,                 Check User Guide for details
		output wire [2:0]   txmargin4,                  //                  .txmargin4,                 Check User Guide for details
		output wire [2:0]   txmargin5,                  //                  .txmargin5,                 Check User Guide for details
		output wire [2:0]   txmargin6,                  //                  .txmargin6,                 Check User Guide for details
		output wire [2:0]   txmargin7,                  //                  .txmargin7,                 Check User Guide for details
		output wire         txdeemph0,                  //                  .txdeemph0,                 Check User Guide for details
		output wire         txdeemph1,                  //                  .txdeemph1,                 Check User Guide for details
		output wire         txdeemph2,                  //                  .txdeemph2,                 Check User Guide for details
		output wire         txdeemph3,                  //                  .txdeemph3,                 Check User Guide for details
		output wire         txdeemph4,                  //                  .txdeemph4,                 Check User Guide for details
		output wire         txdeemph5,                  //                  .txdeemph5,                 Check User Guide for details
		output wire         txdeemph6,                  //                  .txdeemph6,                 Check User Guide for details
		output wire         txdeemph7,                  //                  .txdeemph7,                 Check User Guide for details
		output wire         txswing0,                   //                  .txswing0,                  Check User Guide for details
		output wire         txswing1,                   //                  .txswing1,                  Check User Guide for details
		output wire         txswing2,                   //                  .txswing2,                  Check User Guide for details
		output wire         txswing3,                   //                  .txswing3,                  Check User Guide for details
		output wire         txswing4,                   //                  .txswing4,                  Check User Guide for details
		output wire         txswing5,                   //                  .txswing5,                  Check User Guide for details
		output wire         txswing6,                   //                  .txswing6,                  Check User Guide for details
		output wire         txswing7,                   //                  .txswing7,                  Check User Guide for details
		output wire [1:0]   txsynchd0,                  //                  .txsynchd0,                 Check User Guide for details
		output wire [1:0]   txsynchd1,                  //                  .txsynchd1,                 Check User Guide for details
		output wire [1:0]   txsynchd2,                  //                  .txsynchd2,                 Check User Guide for details
		output wire [1:0]   txsynchd3,                  //                  .txsynchd3,                 Check User Guide for details
		output wire [1:0]   txsynchd4,                  //                  .txsynchd4,                 Check User Guide for details
		output wire [1:0]   txsynchd5,                  //                  .txsynchd5,                 Check User Guide for details
		output wire [1:0]   txsynchd6,                  //                  .txsynchd6,                 Check User Guide for details
		output wire [1:0]   txsynchd7,                  //                  .txsynchd7,                 Check User Guide for details
		output wire         txblkst0,                   //                  .txblkst0,                  Check User Guide for details
		output wire         txblkst1,                   //                  .txblkst1,                  Check User Guide for details
		output wire         txblkst2,                   //                  .txblkst2,                  Check User Guide for details
		output wire         txblkst3,                   //                  .txblkst3,                  Check User Guide for details
		output wire         txblkst4,                   //                  .txblkst4,                  Check User Guide for details
		output wire         txblkst5,                   //                  .txblkst5,                  Check User Guide for details
		output wire         txblkst6,                   //                  .txblkst6,                  Check User Guide for details
		output wire         txblkst7,                   //                  .txblkst7,                  Check User Guide for details
		output wire         txdataskip0,                //                  .txdataskip0,               Check User Guide for details
		output wire         txdataskip1,                //                  .txdataskip1,               Check User Guide for details
		output wire         txdataskip2,                //                  .txdataskip2,               Check User Guide for details
		output wire         txdataskip3,                //                  .txdataskip3,               Check User Guide for details
		output wire         txdataskip4,                //                  .txdataskip4,               Check User Guide for details
		output wire         txdataskip5,                //                  .txdataskip5,               Check User Guide for details
		output wire         txdataskip6,                //                  .txdataskip6,               Check User Guide for details
		output wire         txdataskip7,                //                  .txdataskip7,               Check User Guide for details
		output wire [1:0]   rate0,                      //                  .rate0,                     Check User Guide for details
		output wire [1:0]   rate1,                      //                  .rate1,                     Check User Guide for details
		output wire [1:0]   rate2,                      //                  .rate2,                     Check User Guide for details
		output wire [1:0]   rate3,                      //                  .rate3,                     Check User Guide for details
		output wire [1:0]   rate4,                      //                  .rate4,                     Check User Guide for details
		output wire [1:0]   rate5,                      //                  .rate5,                     Check User Guide for details
		output wire [1:0]   rate6,                      //                  .rate6,                     Check User Guide for details
		output wire [1:0]   rate7,                      //                  .rate7,                     Check User Guide for details
		output wire         rxpolarity0,                //                  .rxpolarity0,               Check User Guide for details
		output wire         rxpolarity1,                //                  .rxpolarity1,               Check User Guide for details
		output wire         rxpolarity2,                //                  .rxpolarity2,               Check User Guide for details
		output wire         rxpolarity3,                //                  .rxpolarity3,               Check User Guide for details
		output wire         rxpolarity4,                //                  .rxpolarity4,               Check User Guide for details
		output wire         rxpolarity5,                //                  .rxpolarity5,               Check User Guide for details
		output wire         rxpolarity6,                //                  .rxpolarity6,               Check User Guide for details
		output wire         rxpolarity7,                //                  .rxpolarity7,               Check User Guide for details
		output wire [2:0]   currentrxpreset0,           //                  .currentrxpreset0,          Check User Guide for details
		output wire [2:0]   currentrxpreset1,           //                  .currentrxpreset1,          Check User Guide for details
		output wire [2:0]   currentrxpreset2,           //                  .currentrxpreset2,          Check User Guide for details
		output wire [2:0]   currentrxpreset3,           //                  .currentrxpreset3,          Check User Guide for details
		output wire [2:0]   currentrxpreset4,           //                  .currentrxpreset4,          Check User Guide for details
		output wire [2:0]   currentrxpreset5,           //                  .currentrxpreset5,          Check User Guide for details
		output wire [2:0]   currentrxpreset6,           //                  .currentrxpreset6,          Check User Guide for details
		output wire [2:0]   currentrxpreset7,           //                  .currentrxpreset7,          Check User Guide for details
		output wire [17:0]  currentcoeff0,              //                  .currentcoeff0,             Check User Guide for details
		output wire [17:0]  currentcoeff1,              //                  .currentcoeff1,             Check User Guide for details
		output wire [17:0]  currentcoeff2,              //                  .currentcoeff2,             Check User Guide for details
		output wire [17:0]  currentcoeff3,              //                  .currentcoeff3,             Check User Guide for details
		output wire [17:0]  currentcoeff4,              //                  .currentcoeff4,             Check User Guide for details
		output wire [17:0]  currentcoeff5,              //                  .currentcoeff5,             Check User Guide for details
		output wire [17:0]  currentcoeff6,              //                  .currentcoeff6,             Check User Guide for details
		output wire [17:0]  currentcoeff7,              //                  .currentcoeff7,             Check User Guide for details
		output wire         rxeqeval0,                  //                  .rxeqeval0,                 Check User Guide for details
		output wire         rxeqeval1,                  //                  .rxeqeval1,                 Check User Guide for details
		output wire         rxeqeval2,                  //                  .rxeqeval2,                 Check User Guide for details
		output wire         rxeqeval3,                  //                  .rxeqeval3,                 Check User Guide for details
		output wire         rxeqeval4,                  //                  .rxeqeval4,                 Check User Guide for details
		output wire         rxeqeval5,                  //                  .rxeqeval5,                 Check User Guide for details
		output wire         rxeqeval6,                  //                  .rxeqeval6,                 Check User Guide for details
		output wire         rxeqeval7,                  //                  .rxeqeval7,                 Check User Guide for details
		output wire         rxeqinprogress0,            //                  .rxeqinprogress0,           Check User Guide for details
		output wire         rxeqinprogress1,            //                  .rxeqinprogress1,           Check User Guide for details
		output wire         rxeqinprogress2,            //                  .rxeqinprogress2,           Check User Guide for details
		output wire         rxeqinprogress3,            //                  .rxeqinprogress3,           Check User Guide for details
		output wire         rxeqinprogress4,            //                  .rxeqinprogress4,           Check User Guide for details
		output wire         rxeqinprogress5,            //                  .rxeqinprogress5,           Check User Guide for details
		output wire         rxeqinprogress6,            //                  .rxeqinprogress6,           Check User Guide for details
		output wire         rxeqinprogress7,            //                  .rxeqinprogress7,           Check User Guide for details
		output wire         invalidreq0,                //                  .invalidreq0,               Check User Guide for details
		output wire         invalidreq1,                //                  .invalidreq1,               Check User Guide for details
		output wire         invalidreq2,                //                  .invalidreq2,               Check User Guide for details
		output wire         invalidreq3,                //                  .invalidreq3,               Check User Guide for details
		output wire         invalidreq4,                //                  .invalidreq4,               Check User Guide for details
		output wire         invalidreq5,                //                  .invalidreq5,               Check User Guide for details
		output wire         invalidreq6,                //                  .invalidreq6,               Check User Guide for details
		output wire         invalidreq7,                //                  .invalidreq7,               Check User Guide for details
		input  wire [31:0]  rxdata0,                    //                  .rxdata0,                   Check User Guide for details
		input  wire [31:0]  rxdata1,                    //                  .rxdata1,                   Check User Guide for details
		input  wire [31:0]  rxdata2,                    //                  .rxdata2,                   Check User Guide for details
		input  wire [31:0]  rxdata3,                    //                  .rxdata3,                   Check User Guide for details
		input  wire [31:0]  rxdata4,                    //                  .rxdata4,                   Check User Guide for details
		input  wire [31:0]  rxdata5,                    //                  .rxdata5,                   Check User Guide for details
		input  wire [31:0]  rxdata6,                    //                  .rxdata6,                   Check User Guide for details
		input  wire [31:0]  rxdata7,                    //                  .rxdata7,                   Check User Guide for details
		input  wire [3:0]   rxdatak0,                   //                  .rxdatak0,                  Check User Guide for details
		input  wire [3:0]   rxdatak1,                   //                  .rxdatak1,                  Check User Guide for details
		input  wire [3:0]   rxdatak2,                   //                  .rxdatak2,                  Check User Guide for details
		input  wire [3:0]   rxdatak3,                   //                  .rxdatak3,                  Check User Guide for details
		input  wire [3:0]   rxdatak4,                   //                  .rxdatak4,                  Check User Guide for details
		input  wire [3:0]   rxdatak5,                   //                  .rxdatak5,                  Check User Guide for details
		input  wire [3:0]   rxdatak6,                   //                  .rxdatak6,                  Check User Guide for details
		input  wire [3:0]   rxdatak7,                   //                  .rxdatak7,                  Check User Guide for details
		input  wire         phystatus0,                 //                  .phystatus0,                Check User Guide for details
		input  wire         phystatus1,                 //                  .phystatus1,                Check User Guide for details
		input  wire         phystatus2,                 //                  .phystatus2,                Check User Guide for details
		input  wire         phystatus3,                 //                  .phystatus3,                Check User Guide for details
		input  wire         phystatus4,                 //                  .phystatus4,                Check User Guide for details
		input  wire         phystatus5,                 //                  .phystatus5,                Check User Guide for details
		input  wire         phystatus6,                 //                  .phystatus6,                Check User Guide for details
		input  wire         phystatus7,                 //                  .phystatus7,                Check User Guide for details
		input  wire         rxvalid0,                   //                  .rxvalid0,                  Check User Guide for details
		input  wire         rxvalid1,                   //                  .rxvalid1,                  Check User Guide for details
		input  wire         rxvalid2,                   //                  .rxvalid2,                  Check User Guide for details
		input  wire         rxvalid3,                   //                  .rxvalid3,                  Check User Guide for details
		input  wire         rxvalid4,                   //                  .rxvalid4,                  Check User Guide for details
		input  wire         rxvalid5,                   //                  .rxvalid5,                  Check User Guide for details
		input  wire         rxvalid6,                   //                  .rxvalid6,                  Check User Guide for details
		input  wire         rxvalid7,                   //                  .rxvalid7,                  Check User Guide for details
		input  wire [2:0]   rxstatus0,                  //                  .rxstatus0,                 Check User Guide for details
		input  wire [2:0]   rxstatus1,                  //                  .rxstatus1,                 Check User Guide for details
		input  wire [2:0]   rxstatus2,                  //                  .rxstatus2,                 Check User Guide for details
		input  wire [2:0]   rxstatus3,                  //                  .rxstatus3,                 Check User Guide for details
		input  wire [2:0]   rxstatus4,                  //                  .rxstatus4,                 Check User Guide for details
		input  wire [2:0]   rxstatus5,                  //                  .rxstatus5,                 Check User Guide for details
		input  wire [2:0]   rxstatus6,                  //                  .rxstatus6,                 Check User Guide for details
		input  wire [2:0]   rxstatus7,                  //                  .rxstatus7,                 Check User Guide for details
		input  wire         rxelecidle0,                //                  .rxelecidle0,               Check User Guide for details
		input  wire         rxelecidle1,                //                  .rxelecidle1,               Check User Guide for details
		input  wire         rxelecidle2,                //                  .rxelecidle2,               Check User Guide for details
		input  wire         rxelecidle3,                //                  .rxelecidle3,               Check User Guide for details
		input  wire         rxelecidle4,                //                  .rxelecidle4,               Check User Guide for details
		input  wire         rxelecidle5,                //                  .rxelecidle5,               Check User Guide for details
		input  wire         rxelecidle6,                //                  .rxelecidle6,               Check User Guide for details
		input  wire         rxelecidle7,                //                  .rxelecidle7,               Check User Guide for details
		input  wire [1:0]   rxsynchd0,                  //                  .rxsynchd0,                 Check User Guide for details
		input  wire [1:0]   rxsynchd1,                  //                  .rxsynchd1,                 Check User Guide for details
		input  wire [1:0]   rxsynchd2,                  //                  .rxsynchd2,                 Check User Guide for details
		input  wire [1:0]   rxsynchd3,                  //                  .rxsynchd3,                 Check User Guide for details
		input  wire [1:0]   rxsynchd4,                  //                  .rxsynchd4,                 Check User Guide for details
		input  wire [1:0]   rxsynchd5,                  //                  .rxsynchd5,                 Check User Guide for details
		input  wire [1:0]   rxsynchd6,                  //                  .rxsynchd6,                 Check User Guide for details
		input  wire [1:0]   rxsynchd7,                  //                  .rxsynchd7,                 Check User Guide for details
		input  wire         rxblkst0,                   //                  .rxblkst0,                  Check User Guide for details
		input  wire         rxblkst1,                   //                  .rxblkst1,                  Check User Guide for details
		input  wire         rxblkst2,                   //                  .rxblkst2,                  Check User Guide for details
		input  wire         rxblkst3,                   //                  .rxblkst3,                  Check User Guide for details
		input  wire         rxblkst4,                   //                  .rxblkst4,                  Check User Guide for details
		input  wire         rxblkst5,                   //                  .rxblkst5,                  Check User Guide for details
		input  wire         rxblkst6,                   //                  .rxblkst6,                  Check User Guide for details
		input  wire         rxblkst7,                   //                  .rxblkst7,                  Check User Guide for details
		input  wire         rxdataskip0,                //                  .rxdataskip0,               Check User Guide for details
		input  wire         rxdataskip1,                //                  .rxdataskip1,               Check User Guide for details
		input  wire         rxdataskip2,                //                  .rxdataskip2,               Check User Guide for details
		input  wire         rxdataskip3,                //                  .rxdataskip3,               Check User Guide for details
		input  wire         rxdataskip4,                //                  .rxdataskip4,               Check User Guide for details
		input  wire         rxdataskip5,                //                  .rxdataskip5,               Check User Guide for details
		input  wire         rxdataskip6,                //                  .rxdataskip6,               Check User Guide for details
		input  wire         rxdataskip7,                //                  .rxdataskip7,               Check User Guide for details
		input  wire [5:0]   dirfeedback0,               //                  .dirfeedback0,              Check User Guide for details
		input  wire [5:0]   dirfeedback1,               //                  .dirfeedback1,              Check User Guide for details
		input  wire [5:0]   dirfeedback2,               //                  .dirfeedback2,              Check User Guide for details
		input  wire [5:0]   dirfeedback3,               //                  .dirfeedback3,              Check User Guide for details
		input  wire [5:0]   dirfeedback4,               //                  .dirfeedback4,              Check User Guide for details
		input  wire [5:0]   dirfeedback5,               //                  .dirfeedback5,              Check User Guide for details
		input  wire [5:0]   dirfeedback6,               //                  .dirfeedback6,              Check User Guide for details
		input  wire [5:0]   dirfeedback7,               //                  .dirfeedback7,              Check User Guide for details
		input  wire         sim_pipe_mask_tx_pll_lock,  //                  .sim_pipe_mask_tx_pll_lock, Check User Guide for details
		input  wire         rx_in0,                     //        hip_serial.rx_in0,                    Check User Guide for details
		input  wire         rx_in1,                     //                  .rx_in1,                    Check User Guide for details
		input  wire         rx_in2,                     //                  .rx_in2,                    Check User Guide for details
		input  wire         rx_in3,                     //                  .rx_in3,                    Check User Guide for details
		input  wire         rx_in4,                     //                  .rx_in4,                    Check User Guide for details
		input  wire         rx_in5,                     //                  .rx_in5,                    Check User Guide for details
		input  wire         rx_in6,                     //                  .rx_in6,                    Check User Guide for details
		input  wire         rx_in7,                     //                  .rx_in7,                    Check User Guide for details
		output wire         tx_out0,                    //                  .tx_out0,                   Check User Guide for details
		output wire         tx_out1,                    //                  .tx_out1,                   Check User Guide for details
		output wire         tx_out2,                    //                  .tx_out2,                   Check User Guide for details
		output wire         tx_out3,                    //                  .tx_out3,                   Check User Guide for details
		output wire         tx_out4,                    //                  .tx_out4,                   Check User Guide for details
		output wire         tx_out5,                    //                  .tx_out5,                   Check User Guide for details
		output wire         tx_out6,                    //                  .tx_out6,                   Check User Guide for details
		output wire         tx_out7,                    //                  .tx_out7,                   Check User Guide for details
		input  wire         hip_reconfig_clk,           //  hip_reconfig_clk.clk,                       Check User Guide for details
		input  wire         hip_reconfig_rst_n,         //  hip_reconfig_rst.reset_n,                   Check User Guide for details
		input  wire [20:0]  hip_reconfig_address,       //      hip_reconfig.address,                   Check User Guide for details
		input  wire         hip_reconfig_read,          //                  .read,                      Check User Guide for details
		output wire [7:0]   hip_reconfig_readdata,      //                  .readdata,                  Check User Guide for details
		output wire         hip_reconfig_readdatavalid, //                  .readdatavalid,             Check User Guide for details
		input  wire         hip_reconfig_write,         //                  .write,                     Check User Guide for details
		input  wire [7:0]   hip_reconfig_writedata,     //                  .writedata,                 Check User Guide for details
		output wire         hip_reconfig_waitrequest    //                  .waitrequest,               Check User Guide for details
	);
endmodule

