source ./arguments_solver.tcl

#This file define the location, io standard, current drive strength, signal width, and signal direction settings for every port available on the FPGA side in the design.
#define all the location assignments in sequence for specific port data with signal width more than one
#DUT_LED4-7
set fpga_led_pio_pin_list {
AR9
AP9
AR8
AR7
}

#DUT_DIP0-3
set fpga_dipsw_pio_pin_list {
AN10
AN11
AM8
AM7
}

#DUT_USER_PB0-3
set fpga_button_pio_pin_list {
AM4
AL4
AL1
AL2
}


set fpga_led_pio_qsys_exported_port_list {
led_pio_external_connection_in_port
led_pio_external_connection_out_port
}

#CLK_DUT_SYS_100M_P/N
dict set pin_assignment_table fpga_clk_100 location AT2
dict set pin_assignment_table fpga_clk_100 io_standard "LVDS"
dict set pin_assignment_table fpga_clk_100 direction input
dict set pin_assignment_table fpga_clk_100 width_in_bits 1
dict set pin_assignment_table fpga_clk_100 qsys_exported_port "clk_100_clk"

#DUT_CPU_RESETn
dict set pin_assignment_table fpga_reset_n location AL6
dict set pin_assignment_table fpga_reset_n io_standard "1.8 V"
dict set pin_assignment_table fpga_reset_n direction input
dict set pin_assignment_table fpga_reset_n width 1
dict set pin_assignment_table fpga_reset_n qsys_exported_port "reset_reset_n"

dict set pin_assignment_table fpga_led_pio location $fpga_led_pio_pin_list
dict set pin_assignment_table fpga_led_pio io_standard "1.8 V"
dict set pin_assignment_table fpga_led_pio direction output
dict set pin_assignment_table fpga_led_pio width_in_bits 4
dict set pin_assignment_table fpga_led_pio qsys_exported_port $fpga_led_pio_qsys_exported_port_list

dict set pin_assignment_table fpga_dipsw_pio location $fpga_dipsw_pio_pin_list
dict set pin_assignment_table fpga_dipsw_pio io_standard "1.8 V"
dict set pin_assignment_table fpga_dipsw_pio direction input
dict set pin_assignment_table fpga_dipsw_pio width_in_bits 4
dict set pin_assignment_table fpga_dipsw_pio qsys_exported_port "dipsw_pio_external_connection_export"

dict set pin_assignment_table fpga_button_pio location $fpga_button_pio_pin_list
dict set pin_assignment_table fpga_button_pio io_standard "1.8 V"
dict set pin_assignment_table fpga_button_pio direction input
dict set pin_assignment_table fpga_button_pio width_in_bits 4
dict set pin_assignment_table fpga_button_pio qsys_exported_port "button_pio_external_connection_export"

puts "Number of ports: [dict size $pin_assignment_table]"
